// ezTransXP.cpp : Defines the initialization routines for the DLL.
//
#pragma warning(disable:4996)

#include "stdafx.h"
#include "ezTransXP.h"
#include "hash.hpp"
#include "tstring.h"
#include <stdio.h>
#include <process.h>
#include <map>
#include <vector>
#include <string>

//    2Byte :    KS5601  ȣ ڵ
//  2Byte : SHIFT-JIS  ȣ ڵ
const char _SHIFT_JIS_CHAR_MAP[][4] = {
	{'\xA1', '\xCD', '\x81', '\x8F'},	// '\\'
	{'\xA3', '\xC0', '\x81', '\x97'},	// '@'
	{'\xA3', '\xA8', '\x81', '\x69'},	// '('
	{'\xA3', '\xA9', '\x81', '\x6A'},	// ')'
	{'\xA3', '\xBC', '\x81', '\x83'},	// '<'
	{'\xA3', '\xBE', '\x81', '\x84'},	// '>'
	{'\xA3', '\xDB', '\x81', '\x6D'},	// '['
	{'\xA3', '\xDD', '\x81', '\x6E'},	// ']'
	{'\xA3', '\xFB', '\x81', '\x6F'},	// '{'
	{'\xA3', '\xFD', '\x81', '\x70'},	// '}'
	{'\xA2', '\xC8', '\x81', '\x4A'},	// 
	{'\xA2', '\xC8', '\x81', '\x4B'},	// 
	{'\xA2', '\xC8', '\x81', '\x8D'},	// 
	{'\xA2', '\xC7', '\x81', '\x4C'},	// 
	{'\xA2', '\xC7', '\x81', '\x4D'},	// 
	{'\xA2', '\xC7', '\x81', '\x8C'},	// 
	{'\xA1', '\xAE', '\x81', '\x65'},	// 
	{'\xA1', '\xAF', '\x81', '\x66'},	// 
	{'\xA1', '\xB0', '\x81', '\x67'},	// 
	{'\xA1', '\xB1', '\x81', '\x68'},	// 

	{'\x00', '\x00', '\x00', '\x00'}
};

HWND	g_hSettingWnd = NULL;
LPSTR	g_pOptStrBuf = NULL;


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// The one and only CezTransXPApp object

CezTransXPApp theApp;


// Export Functions
extern "C" __declspec(dllexport) BOOL __stdcall OnPluginInit(HWND hSettingWnd, LPSTR cszSettingStringBuffer)
{
	return theApp.OnPluginInit(hSettingWnd, cszSettingStringBuffer);
}

extern "C" __declspec(dllexport) BOOL __stdcall OnPluginOption()
{
	return theApp.OnPluginOption();
}

extern "C" __declspec(dllexport) BOOL __stdcall OnPluginClose()
{
	return theApp.OnPluginClose();
}

extern "C" __declspec(dllexport) BOOL __stdcall Translate(LPCSTR cszJapanese, LPSTR szKorean, int nBufSize)
{
	return theApp.Translate(cszJapanese, szKorean, nBufSize);
}

/*
class CustomDic {
	private:
		

}
*/
//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//


// CezTransXPApp

BEGIN_MESSAGE_MAP(CezTransXPApp, CWinApp)
END_MESSAGE_MAP()


// CezTransXPApp construction

CezTransXPApp::CezTransXPApp()
	: m_hTransThread(NULL)
	, m_hRequestEvent(NULL)
	, m_hResponseEvent(NULL)
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}




// CezTransXPApp initialization

BOOL CezTransXPApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}

BOOL CezTransXPApp::OnPluginInit( HWND hSettingWnd, LPSTR cszSettingStringBuffer )
{
	TRACE(_T("CezTransXPApp::OnPluginInit() begin \n"));

	BOOL bRetVal = FALSE;

	// ɼ Ʈ  
	g_pOptStrBuf = cszSettingStringBuffer;

	// ȭ ü ʱȭ
	InitializeCriticalSection(&m_csTrans);
	m_hRequestEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	m_hResponseEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	m_hTransThread = (HANDLE)_beginthreadex(NULL, 0, TransThreadFunc, this, 0, NULL);
	if(NULL == m_hTransThread)
	{
		MessageBox(hSettingWnd, _T("Ʈ 带   ϴ."), _T("ezTransXP Initialize Error"), MB_OK);
	}
	else
	{
		WaitForSingleObject(m_hResponseEvent, INFINITE);
		if(!m_strErrorMsg.IsEmpty())
		{
			MessageBox(hSettingWnd, _T("Ʈ ʱȭ ߽ϴ."), _T("ezTransXP Initialize Error"), MB_OK);
		}
		else
		{
			bRetVal = TRUE;
		}

	}
	
	// ڻ ʱȭ


	TRACE(_T("CezTransXPApp::OnPluginInit() end \n"));

	return bRetVal;

}

wstring CezTransXPApp::getGamePath(){
	//   
	// ⸮⸮ ÷ο ۿ ==
	wchar_t wszExecPath[MAX_PATH];
	GetModuleFileName(NULL, wszExecPath, MAX_PATH);
	wchar_t* pFind = wcsrchr(wszExecPath, _T('\\'));
	if(pFind == NULL) throw -1;
	*pFind = L'\0';

	wstring Temp=wszExecPath;
	return Temp;
}

int CezTransXPApp::WstringToInt(wstring In){
	const wchar_t *Temp=In.c_str();
	int Ans=0;
	int Len=In.length();
	for(int A=0;A<Len;A++){
		Ans=Ans*10;
		Ans+=Temp[A]-L'0';
	}
	return Ans;
}

void CezTransXPApp::InitCustomDic()
{

	//ϴ    
	CezTransXPApp::CDicJpn.clear();

	FILE * SRC;

	wstring GamePath=getGamePath();
	wstring ReadFile = GamePath+L"\\ATData\\CustomDic.txt";
	SRC = _wfopen(ReadFile.c_str(),L"rt,ccs=UTF-8");

	wchar_t _JpKrText[5000]=L"";
	wstring JpKrText=L"";
	wstring JpText=L"";
	wstring KrText=L"";

	// Pre Jp ѱ
	// Post Kr ѱ.
	int JpKrTab=0;
	int JpKrLen=0;
	int JpKrComment=0;
	int WordN=0;
	
	if(SRC!=NULL)
	{
		while(fgetws(_JpKrText,5000,SRC))
		{
			JpKrText=_JpKrText;

			JpKrTab=JpKrText.find(L"\t");
			//  ġ ã
			JpKrLen=JpKrText.length()-1;
			// ̱ϰ

			JpKrComment=JpKrText.find(L"//");
			if(JpKrComment!=-1){
				// // پٸ
				if(JpKrComment<JpKrTab){
					JpKrTab=-1;
				}
				JpKrLen=JpKrComment;
			}

			if(JpKrTab!=-1){
				//JpKrTab Ͱ ɷ,  ε ϰ
				JpText=JpKrText.substr(0,JpKrTab);
				if (JpKrText.substr(JpKrLen-1,1)==L"\r"){
					KrText=JpKrText.substr(JpKrTab+1,JpKrLen-JpKrTab-1);
				}
				else {
					KrText=JpKrText.substr(JpKrTab+1,JpKrLen-JpKrTab);
				}
				//и!
	
				if(KrText.find(L"\t")==-1){ // ڿ   ߰!

					DicWord InsertWord;
					InsertWord.WordLen=JpText.length();
					InsertWord.WordN=WordN;
					CezTransXPApp::CDicJpn[JpText]=InsertWord;
					WordN++;
					//Ϻ κ Է

					CezTransXPApp::CDicKor.push_back(KrText);
					//ѱ κ Է
				}
			}
		}
		fclose(SRC);
	}
	else {
		//   
		wstring _Directory = GamePath +  L"\\ATData";
		CreateDirectory(_Directory.c_str(), NULL); //
		FILE * ReadMe;
		ReadMe = _wfopen(ReadFile.c_str(),L"wt,ccs=UTF-8");
		if(ReadMe!=NULL){
		fwprintf(ReadMe,L"//---------------------------------\n");
		fwprintf(ReadMe,L"//  ÷ ȳ\n");
		fwprintf(ReadMe,L"//---------------------------------\n");
		fwprintf(ReadMe,L"\n");
		fwprintf(ReadMe,L"// Ͽ ϴ Ϻ ѱ ߰ؼ\n");
		fwprintf(ReadMe,L"//  ߰  ֽϴ.\n");
		fwprintf(ReadMe,L"//( Ʈ    ٸϴ.)\n");
		fwprintf(ReadMe,L"\n");
		fwprintf(ReadMe,L"//ܾ\n");
		fwprintf(ReadMe,L"//Ϻ\t()\tѱ\n");
		fwprintf(ReadMe,L"//  Էϸ,\n");
		fwprintf(ReadMe,L"// տ '//' ̸,   ߰ ʴ ּ νĵ˴ϴ.\n");
		fwprintf(ReadMe,L"\n");
		fwprintf(ReadMe,L"//\n");
		fwprintf(ReadMe,L"ȫ\tƶƮ\n");
		fwprintf(ReadMe,L"Ϋի髰ª\tHide_D\n");
		fclose(ReadMe);
		}
	}
}

LPSTR CezTransXPApp::PreCustomDic(LPCSTR Source)
{
	wchar_t _JpOriginal[2048]=L"";
	MyMultiByteToWideChar(932,0,Source,-1,_JpOriginal,2048);
	wstring JpOriginal=_JpOriginal;
	//Լ 

	int JpLen=JpOriginal.length();

	wstring Output=L"";

	wstring Temp=L"";
	map<wstring, struct DicWord>::iterator Temp2;
	wchar_t Temp3[20]=L"";
	wstring Temp4=L"";

	int Spoint=0;
	for(int A=0;A<JpLen;A++){
		for(int B=JpLen-1;B>=A;B--){//  ܾ ãƾ ϹǷ ڿ ´
			Temp=JpOriginal.substr(A,B-A+1);
			//ڿ ڸ

			Temp2 = CezTransXPApp::CDicJpn.find(Temp);
			// ڿ ˻
			if(Temp2 != CezTransXPApp::CDicJpn.end()){// Ͱ ִٸ!
				
				Output += JpOriginal.substr(Spoint,A-Spoint);
				//̰ պκ ŭ ߰ϰ!
				for(int i=0;i<20;i++)Temp3[i]=NULL;
				swprintf(Temp3,L"<[(%d)]>",Temp2->second.WordN);
				Temp4=Temp3;
				Output += Temp4;
				//߰  ѵ Է

				A+=Temp2->second.WordLen-1;
				Spoint=A+1;
				//׸   ڷ δ.

				break;
			}
		}
	}
	Output += JpOriginal.substr(Spoint,JpLen-Spoint);
	//׸  ޺κ ߰!
	//ȯ
	LPSTR Outcome="";
	MyWideCharToMultiByte(932,0,Output.c_str(),-1,Outcome,2000,NULL,NULL);

	return Outcome;
}

LPSTR CezTransXPApp::PostCustomDic(string Source)
{
	wchar_t _KrOriginal[2048]=L"";
	MyMultiByteToWideChar(949,0,Source.c_str(),-1,_KrOriginal,2048);
	wstring KrOriginal=_KrOriginal;
	//Լ 

	int KrLen=KrOriginal.length();

	wstring Output=L"";
	wstring Temp=L"";

	int WordN=0;
	int Spoint=0;
	int DicStart=0;
	int DicEnd=0;
	int WordMode=0;

	for(int A=0;A<KrLen;A++){
		// κ <[(****)]>
		if(KrOriginal[A]==L'<'){//ùڶ!
			WordMode=1;
		}
		else if(WordMode==1&&KrOriginal[A]==L'['){//° ڶ!
			WordMode=2;
		}
		else if(WordMode==2&&KrOriginal[A]==L'('){//° ڱ  õȴٸ!
			WordMode=3;
			DicStart=A+1;
		}
		else if(WordMode==3&&KrOriginal[A]==L')'){//ݱ ùڶ!
			WordMode=4;
			DicEnd=A-1;
		}
		else if(WordMode==4&&KrOriginal[A]==L']'){//ݱ ° ڶ!
			WordMode=5;
		}
		else if(WordMode==5&&KrOriginal[A]==L'>'){//ݱ °¥  õȴٸ!
			WordMode=0;
			// ʱȭ

			Temp=KrOriginal.substr(DicStart,DicEnd-DicStart+1);
			WordN=WstringToInt(Temp);
			// ܾ ϰ

			Output += KrOriginal.substr(Spoint,DicStart-Spoint-3);
			// ܾ ձ ؽƮ ű

			Output += CezTransXPApp::CDicKor[WordN];
			// vector  ȣ ܾ Է

			Spoint=A+1;
		}
	}
	Output += KrOriginal.substr(Spoint,KrLen-Spoint);
	// ==

	//ȯ
	LPSTR Outcome="";
	MyWideCharToMultiByte(949,0,Output.c_str(),-1,Outcome,2000,NULL,NULL);
	// ۾  TRUE, н FALSE ȯ 
	return Outcome;
}


void CezTransXPApp::InitEZTrans()
{
	m_strErrorMsg = _T("");

	try
	{
		m_strHomeDir = GetEZTransHomeDir();

		if( m_strHomeDir.IsEmpty() ) throw _T("EZ Trans XP  ġ θ ã  ϴ.");

		ZeroMemory(&m_EZDLL, sizeof(m_EZDLL));

		// J2K   ε
		CString strJ2KDllPath = m_strHomeDir + _T("\\..\\J2KEngine.dll");
		m_EZDLL.hJKMod = LoadLibrary(strJ2KDllPath);	
		if (m_EZDLL.hJKMod == NULL) throw _T("J2KEngine.dll ε  ϴ.");

		// DLLκ Լ  
		FARPROC pFuncAddr = NULL;

		pFuncAddr = GetProcAddress(m_EZDLL.hJKMod, "J2K_InitializeEx"); 
		memcpy( &m_EZDLL.J2K_InitializeEx, &pFuncAddr, sizeof(FARPROC) );

		pFuncAddr = GetProcAddress(m_EZDLL.hJKMod, "J2K_TranslateMMNT"); 
		memcpy( &m_EZDLL.J2K_TranslateMMNT, &pFuncAddr, sizeof(FARPROC) );

		pFuncAddr = GetProcAddress(m_EZDLL.hJKMod, "J2K_FreeMem"); 
		memcpy( &m_EZDLL.J2K_FreeMem, &pFuncAddr, sizeof(FARPROC) );

		pFuncAddr = GetProcAddress(m_EZDLL.hJKMod, "J2K_StopTranslation"); 
		memcpy( &m_EZDLL.J2K_StopTranslation, &pFuncAddr, sizeof(FARPROC) );

		pFuncAddr = GetProcAddress(m_EZDLL.hJKMod, "J2K_Terminate"); 
		memcpy( &m_EZDLL.J2K_Terminate, &pFuncAddr, sizeof(FARPROC) );


		if (m_EZDLL.J2K_InitializeEx == NULL || m_EZDLL.J2K_TranslateMMNT == NULL ||
			m_EZDLL.J2K_FreeMem == NULL || m_EZDLL.J2K_StopTranslation == NULL ||
			m_EZDLL.J2K_Terminate == NULL)  throw _T("߸ J2KEngine.dll Դϴ.");

#ifdef UNICODE
		char szHomeDir[MAX_PATH];
		::WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)m_strHomeDir, -1, szHomeDir, MAX_PATH, NULL, NULL);
		m_EZDLL.J2K_InitializeEx(EZTR_INIT_STR, szHomeDir);
#else
		m_EZDLL.J2K_InitializeEx(EZTR_INIT_STR, (LPCSTR)m_strHomeDir);
#endif

	}
	catch (LPCTSTR strErr)
	{
		m_strErrorMsg = strErr;
		//MessageBox(hSettingWnd, strErr, _T("ezTransXP Initialize Error"), MB_OK);
	}


	return;
}



void CezTransXPApp::CloseEZTrans()
{
	if (m_EZDLL.J2K_StopTranslation && m_EZDLL.J2K_Terminate)
	{
		m_EZDLL.J2K_StopTranslation(0);		/*    m_EZDLL.J2K_Terminate(); */
	}

	if (m_EZDLL.hJKMod)
	{
		/*    FreeLibrary(m_EZDLL.hJKMod); */
	}

	ZeroMemory(&m_EZDLL, sizeof(m_EZDLL));

}

BOOL CezTransXPApp::OnPluginOption()
{
	//ɼ  !!!!!!
	
	if(g_hSettingWnd && IsWindow(g_hSettingWnd))
	{
		::MessageBox(g_hSettingWnd, _T("Դϴ."), _T("ezTransXP Plugin with CustomDic"), MB_OK);
		//DialogBox((HINSTANCE)g_hThisModule, MAKEINTRESOURCE(IDD_OPTIONDIALOG), g_hSettingWnd, OptionDialogProc);
	}
	return TRUE;
}


BOOL CezTransXPApp::OnPluginClose()
{
	if(m_hTransThread)
	{
		HANDLE hTmp = m_hTransThread;
		m_hTransThread = NULL;
		::SetEvent(m_hRequestEvent);
		::WaitForSingleObject(m_hTransThread, 3000);
		::CloseHandle(m_hTransThread);
	}

	// ȭ ü ȭ
	::CloseHandle(m_hRequestEvent);
	::CloseHandle(m_hResponseEvent);
	m_hRequestEvent = NULL;
	m_hResponseEvent = NULL;
	DeleteCriticalSection(&m_csTrans);
	
	return TRUE;
}

BOOL CezTransXPApp::Translate( LPCSTR cszJapanese, LPSTR szKorean, int nBufSize )
{
	BOOL bRetVal = FALSE;

	EnterCriticalSection(&m_csTrans);

	m_nBufSize = nBufSize;
	m_pJpnText = cszJapanese;
	m_pKorText = szKorean;

	::SetEvent(m_hRequestEvent);
	if(::WaitForSingleObject(m_hResponseEvent, 3000) == WAIT_OBJECT_0) bRetVal = TRUE;

	LeaveCriticalSection(&m_csTrans);

	return bRetVal;
}



// Ʈ Ȩ 丮 ʱȭ
CString CezTransXPApp::GetEZTransHomeDir()
{
	CString strRetVal = _T("");

	TCHAR szHomeDir[MAX_PATH];
	HKEY hKey;
	DWORD dwLen = MAX_PATH;

	try
	{
		if (RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\ChangShin\\ezTrans"), 0,
			KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS) throw -1;


		if (RegQueryValueEx(hKey, _T("FilePath"), NULL, NULL, (LPBYTE)szHomeDir,
			&dwLen) != ERROR_SUCCESS) throw -2;

		RegCloseKey(hKey);

		if ( _tcslen(szHomeDir) == 0 ) throw -3;

		strRetVal.Format(_T("%s\\Dat"), szHomeDir);
	}
	catch (int nErrCode)
	{
		nErrCode = nErrCode;
	}

	return strRetVal;
}



unsigned int __stdcall CezTransXPApp::TransThreadFunc(void* pParam)
{
	// ؽƮ ĳ
	map<UINT, CTextElement*> mapCache;

	CTextElement CacheHead;
	CTextElement CacheTail;
	CacheHead.pNextLink = &CacheTail;
	CacheTail.pPrevLink = &CacheHead;
	
	LPSTR _m_pJpnText="";

	CezTransXPApp* pThis = (CezTransXPApp*)pParam;

	pThis->InitEZTrans();
	::SetEvent(pThis->m_hResponseEvent);

	while(pThis->m_hTransThread)
	{
		WaitForSingleObject(pThis->m_hRequestEvent, INFINITE);
		if(pThis->m_hTransThread == NULL) break;

		if('\0' == pThis->m_pJpnText[0])
		{
			pThis->m_pKorText[0] = '\0';
		}
		else
		{
			//  ó ==
			_m_pJpnText=pThis->PreCustomDic(pThis->m_pJpnText);

			//   ؽƮ ؽ ϱ
			UINT dwTextHash = MakeStringHash(_m_pJpnText);

			// ĳÿ ãƺ
			map<UINT, CTextElement*>::iterator iter = mapCache.find(dwTextHash);
			CTextElement* pTextElem = NULL;
			
			// ĳÿ 
			if(mapCache.end() != iter)
			{
				pTextElem = iter->second;

				// Ʈ 
				pTextElem->pPrevLink->pNextLink = pTextElem->pNextLink;
				pTextElem->pNextLink->pPrevLink = pTextElem->pPrevLink;

			}
			// ĳÿ  Ʈ 
			else
			{
				char szEncodedJpnText[2048];
				pThis->EncodeTwoByte(_m_pJpnText, szEncodedJpnText);
				char* szTrans = pThis->m_EZDLL.J2K_TranslateMMNT(0, szEncodedJpnText);

				if(szTrans)
				{
					char szDecodedKorText[2048];
					pThis->DecodeTwoByte(szTrans, szDecodedKorText);
					pThis->FilterTrace(_m_pJpnText, szDecodedKorText);
					pThis->m_EZDLL.J2K_FreeMem(szTrans);

					pTextElem = new CTextElement();
					pTextElem->dwHash = dwTextHash;
					pTextElem->strTranslatedText = szDecodedKorText;


					// ĳð  áٸ ڸ Ȯ 
					if(mapCache.size() >= 10000)
					{
						CTextElement* pDelElem = CacheTail.pPrevLink;
						CacheTail.pPrevLink = pDelElem->pPrevLink;

						mapCache.erase(pDelElem->dwHash);
						delete pDelElem;
					}

					// ĳÿ 
					mapCache.insert(pair<UINT, CTextElement*>(dwTextHash, pTextElem));
				}

			}


			if(pTextElem && pThis->m_pKorText)
			{
				pTextElem->strTranslatedText = pThis->PostCustomDic(pTextElem->strTranslatedText);
				int nLen = (int)pTextElem->strTranslatedText.length();

				if( nLen > (pThis->m_nBufSize-1) )
				{
					strncpy(pThis->m_pKorText, pTextElem->strTranslatedText.c_str(), pThis->m_nBufSize-1);
					pThis->m_pKorText[pThis->m_nBufSize-1] = _T('\0');
				}
				else
				{
					strcpy(pThis->m_pKorText, pTextElem->strTranslatedText.c_str());
				}
				
				//   
				pTextElem->pPrevLink = &CacheHead;
				pTextElem->pNextLink = CacheHead.pNextLink;

				CacheHead.pNextLink->pPrevLink = pTextElem;
				CacheHead.pNextLink = pTextElem;
			}

		}// end of else of if('\0' == pThis->m_pJpnText[0])

		::SetEvent(pThis->m_hResponseEvent);
	}
	
	//  ҵ 
	TRACE(_T("[aral1] Map : %d"), mapCache.size());
	for(map<UINT, CTextElement*>::iterator iter = mapCache.begin();
		iter != mapCache.end();
		iter++)
	{
		CTextElement* pTextElem = iter->second;
		if(pTextElem) delete pTextElem;
	}


	pThis->CloseEZTrans();

	return 0;
}



//////////////////////////////////////////////////////////////////////////
//
// Ⱑ ȣ  ٿ  Ϻ ӿ  
//  ̷  
// ex) "()⸦ Ծ." -> "Ұ⸦ Ծ."
//
//////////////////////////////////////////////////////////////////////////
void CezTransXPApp::FilterTrace(LPCSTR cszJpnText, LPSTR szKorText)
{
	if(NULL==cszJpnText || NULL==szKorText || '\0'==cszJpnText[0] || '\0'==szKorText[0]) return;

	UINT_PTR exist1 = (UINT_PTR)strchr(cszJpnText, '{');	// | (UINT_PTR)strstr(cszJpnText, "\x81\x6F");
	UINT_PTR exist2 = (UINT_PTR)strchr(cszJpnText, '(');	// | (UINT_PTR)strstr(cszJpnText, "\x81\x69");;
	UINT_PTR exist3 = (UINT_PTR)strchr(cszJpnText, '<');	// | (UINT_PTR)strstr(cszJpnText, "\x81\x69");;
	
	size_t len = strlen(szKorText);
	char* szOrigText = new char[len+1];
	memcpy(szOrigText, szKorText, len+1);
	
	size_t i = 0;	//  ε
	size_t j = 0;	//  ε

	while(i<len)
	{
		if((BYTE)szOrigText[i] >= 0x80 && (BYTE)szOrigText[i+1] != '\0')
		{
			if((BYTE)szOrigText[i] == 0xA1 && (BYTE)szOrigText[i+1] == 0xA1)
			{
				i += 2;
				szKorText[j++] = ' ';
			}
			else
			{
				szKorText[j++] = szOrigText[i++];
				szKorText[j++] = szOrigText[i++];
			}
		}
		else
		{
			if(szOrigText[i] == '{' && exist1 == NULL)
			{
				while(szOrigText[i] != '}' && i<len)
				{
					if((BYTE)szOrigText[i] >= 0x80 && (BYTE)szOrigText[i+1] != '\0') i++;
					i++;
				}
				if(i<len) i++;
				if(szOrigText[i]==' ') i++;
			}
			else if(szOrigText[i] == '(' && exist2 == NULL)
			{
				while(szOrigText[i] != ')' && i<len)
				{
					if((BYTE)szOrigText[i] >= 0x80 && (BYTE)szOrigText[i+1] != '\0') i++;
					i++;
				}
				if(i<len) i++;
				if(szOrigText[i]==' ') i++;
			}
			else if(szOrigText[i] == '<' && exist3 == NULL)
			{
				while(szOrigText[i] != '>' && i<len)
				{
					if((BYTE)szOrigText[i] >= 0x80 && (BYTE)szOrigText[i+1] != '\0') i++;
					i++;
				}
				if(i<len) i++;
				if(szOrigText[i]==' ') i++;

				if(j>0 && ':' == szKorText[j-1]) szKorText[j-1] = ' ';
			}
			else
			{
				szKorText[j++] = szOrigText[i++];
			}
		}
	}

	delete [] szOrigText;

	// Trim
	do 
	{
		szKorText[j] = '\0';
		j--;
	} while (j>0 && ' ' == szKorText[j]);

	
	//OutputDebugStringA(szKorText);
	//OutputDebugStringA("");
}




//////////////////////////////////////////////////////////////////////////
//
//  Ưڸ Ʈ  ASCIIڵ ٲ ̸ 
// ϱ   ȯŴ
// ex) "檫" -> "(\atA3BC)檫(\atA3BE)"
//
//////////////////////////////////////////////////////////////////////////
void CezTransXPApp::EncodeTwoByte(LPCSTR cszJpnSrc, LPSTR szJpnTar)
{
	if(NULL==cszJpnSrc || NULL==szJpnTar) return;

	if('\0'==cszJpnSrc[0])
	{
		szJpnTar[0] = '\0';
		return;
	}
	
	size_t len = strlen(cszJpnSrc);

	size_t i = 0;	//  ε
	size_t j = 0;	//  ε

	while(i<len)
	{
		if((BYTE)cszJpnSrc[i] >= 0x80 && (BYTE)cszJpnSrc[i+1] != '\0')
		{
			int nTarInc = 2;

			szJpnTar[j] = cszJpnSrc[i];
			szJpnTar[j+1] = cszJpnSrc[i+1];

			for(int k=0; _SHIFT_JIS_CHAR_MAP[k][0]; k++)
			{
				if(_SHIFT_JIS_CHAR_MAP[k][2] == cszJpnSrc[i]
					&& _SHIFT_JIS_CHAR_MAP[k][3] == cszJpnSrc[i+1])
				{
					nTarInc = sprintf(&szJpnTar[j], "(\\at%.2X%.2X)", (BYTE)_SHIFT_JIS_CHAR_MAP[k][0], (BYTE)_SHIFT_JIS_CHAR_MAP[k][1]);
				}
			}
			
			i += 2;
			j += nTarInc;
		}
		else
		{
			szJpnTar[j++] = cszJpnSrc[i++];
		}
	}

	szJpnTar[j] = '\0';
	
	//OutputDebugStringA(cszJpnSrc);
	//OutputDebugStringA(szJpnTar);
}




//////////////////////////////////////////////////////////////////////////
//
// Ʈ   ȯ״ Ưȣ 
// ex)  "(\atA3BC)ΰ(\atA3BE)" -> "ΰ"
//
//////////////////////////////////////////////////////////////////////////
void CezTransXPApp::DecodeTwoByte(LPCSTR cszKorSrc, LPSTR szKorTar)
{
	if(NULL==cszKorSrc || NULL==szKorTar) return;

	if('\0'==cszKorSrc[0])
	{
		szKorTar[0] = '\0';
		return;
	}

	size_t len = strlen(cszKorSrc);

	size_t i = 0;	//  ε
	size_t j = 0;	//  ε

	while(i<len)
	{
		size_t nCopyLen = len-i;
		const char* pEncPtr = strstr(&cszKorSrc[i], "(\\at");
		
		if(pEncPtr && ')' == *(pEncPtr+8) )
		{
			nCopyLen = (UINT_PTR)pEncPtr - (UINT_PTR)(&cszKorSrc[i]);
		}
		else
		{
			pEncPtr = NULL;
		}

		// Ϲ ڿ 
		memcpy(&szKorTar[j], &cszKorSrc[i], nCopyLen);
		i += nCopyLen;
		j += nCopyLen;

		if(pEncPtr)
		{
			// Ư  ڵ
			sscanf(pEncPtr+4, "%2x%2x", &szKorTar[j], &szKorTar[j+1]);
			
			i += 9;
			j += 2;
		}

	}

	szKorTar[j] = '\0';

	//OutputDebugStringA(cszKorSrc);
	//OutputDebugStringA(szKorTar);

}