// ezTransXP.h : main header file for the ezTransXP DLL
//

#pragma once

#ifndef __AFXWIN_H__
	#error "include 'stdafx.h' before including this file for PCH"
#endif

#include "resource.h"		// main symbols
#include <map>
#include <vector>
#include <string>


#define EZTR_INIT_STR "CSUSER123455"

using namespace std;

// Export Functions
extern "C" __declspec(dllexport) BOOL __stdcall OnPluginInit(HWND hSettingWnd, LPSTR cszSettingStringBuffer);
extern "C" __declspec(dllexport) BOOL __stdcall OnPluginOption();
extern "C" __declspec(dllexport) BOOL __stdcall OnPluginClose();
extern "C" __declspec(dllexport) BOOL __stdcall Translate(LPCSTR cszJapanese, LPSTR szKorean, int nBufSize);

// CTextElement Ŭ
class CTextElement
{
public:
	
	CTextElement*	pPrevLink;
	CTextElement*	pNextLink;
	UINT			dwHash;
	string			strTranslatedText;

	CTextElement() : pPrevLink(NULL), pNextLink(NULL), dwHash(0x00000000) {}
};

struct DicWord
{
		int WordN;
		int WordLen;
};

// CezTransXPApp
// See ezTransXP.cpp for the implementation of this class
//

class CezTransXPApp : public CWinApp
{
	struct
	{
		HMODULE hJKMod;
		int (__stdcall * J2K_InitializeEx)(const char* initStr, const char* homeDir);
		char* (__stdcall * J2K_TranslateMMNT)(int data0, const char *jpStr);
		int (__stdcall * J2K_FreeMem)(char *krStr);
		int (__stdcall * J2K_StopTranslation)(int data0);
		int (__stdcall * J2K_Terminate)(void);
	} m_EZDLL;

private:
	HANDLE	m_hTransThread;
	HANDLE	m_hRequestEvent;
	HANDLE	m_hResponseEvent;
	CRITICAL_SECTION m_csTrans;
	LPCSTR	m_pJpnText;
	LPSTR	m_pKorText;
	int		m_nBufSize;
	CString m_strHomeDir;
	CString m_strErrorMsg;

	//   ܾ
	map<wstring, struct DicWord> CDicJpn;
	vector<wstring> CDicKor;
	
	//   ܾ
	//map<wstring, struct DicWord> GDicJpn;
	//vector<wstring> GDicKor;

	wstring getGamePath(void);
	int WstringToInt(wstring In);

	CString GetEZTransHomeDir();	// Ʈ Ȩ 丮 
	void	InitEZTrans();
	void	CloseEZTrans();

	void	InitCustomDic();

	LPSTR	PreCustomDic(LPCSTR Source);
	LPSTR	PostCustomDic(string Source);

	static unsigned int __stdcall TransThreadFunc(void* pParam);
	void	FilterTrace(LPCSTR cszJpnText, LPSTR szKorText);
	void	EncodeTwoByte(LPCSTR cszJpnSrc, LPSTR szJpnTar);
	void	DecodeTwoByte(LPCSTR cszKorSrc, LPSTR szKorTar);

public:
	CezTransXPApp();

	BOOL OnPluginInit(HWND hSettingWnd, LPSTR cszSettingStringBuffer);
	BOOL OnPluginOption();
	BOOL OnPluginClose();
	BOOL Translate(LPCSTR cszJapanese, LPSTR szKorean, int nBufSize);

	// Overrides
public:
	virtual BOOL InitInstance();

	DECLARE_MESSAGE_MAP()
};
